import xarray as xr
import numpy as np
import matplotlib.pyplot as plt

f = xr.open_dataset('../diag/freerun/ensemble.nc')
x = f['Mesh2_node_x'].to_numpy()
y = f['Mesh2_node_y'].to_numpy()
triangles = f['Mesh2_face_nodes'].to_numpy()
x_c, y_c = np.mean(x[triangles], axis=-1), np.mean(y[triangles], axis=-1)

f = open('square50.msh')
for i in range(13):
	l = f.readline() # skip headers
n_nodes = int(f.readline()) # '8\n'
print (n_nodes)
nodes = np.fromfile(f,count=n_nodes*4, sep=" ").reshape((n_nodes,4))[:, 1:3]
xs, ys = nodes[:, 0], nodes[:, 1]

for i in range(32+3):
	l = f.readline()
elems = np.fromfile(f,count=40*8, sep=" ", dtype=int).reshape((40,8))[:, 5:]
f.close()

elems = elems - 1
xs_c = xs[elems].mean(axis=1)
ys_c = ys[elems].mean(axis=1)

V_ind = np.zeros_like(x, dtype=bool)
for i, (xx_s, yy_s) in enumerate(zip(xs, ys)):
	d = (xx_s - x)*(xx_s - x) + (yy_s - y)*(yy_s - y)
	V_ind[np.argmin(d)] = True

np.save('SparseObs.npy', V_ind)

C_ind = np.zeros_like(x_c, dtype=bool)
for i, (xx_s, yy_s) in enumerate(zip(xs_c, ys_c)):
	d = (xx_s - x_c)*(xx_s - x_c) + (yy_s - y_c)*(yy_s - y_c)
	C_ind[np.argmin(d)] = True

print (C_ind.shape)
np.save('SparseObs_C.npy', C_ind)
plt.triplot(xs, ys)
plt.scatter(x_c, y_c, color='r')
plt.triplot(x, y, triangles, color='k')
plt.scatter(x[V_ind], y[V_ind], color='r')
plt.scatter(x_c[C_ind], y_c[C_ind], color='b', marker='+', s=100)
plt.show()
