from mpi4py import MPI


class parallelization:
    def __init__(self, n_model_PE):
        self.PE = dict()
        self.n_model_PE = n_model_PE
        self.initWorld()
        self.getModelComm()
        self.getCoupleComm()

    def initWorld(self):
        self.comm_world = MPI.COMM_WORLD
        self.rank_world = self.comm_world.Get_rank()
        self.size_world = self.comm_world.Get_size()

    def getModelComm(self):
        """Evenly divde the CPUs for each member
        """
        color = self.rank_world//self.n_model_PE
        self.task_id = color + 1
        self.comm_model = self.comm_world.Split(color, self.rank_world)
        self.rank_model = self.comm_model.Get_rank()
        self.size_model = self.comm_model.Get_size()
        self.PE['forecast'] = self.task_id == 1
        self.PE['analysis'] = self.task_id > 0
        self.PE['ensemble'] = self.task_id > 0

    def getCoupleComm(self):
        """Communicator for coupling
        First rank of each member is in one communicator
        The rest is in other
        """
        # coupling PEs
        if self.rank_model == 0:
            color = 0
        elif self.rank_model != 0:
        # rest of PEs
            color = 1
        self.comm_couple = self.comm_world.Split(color, self.rank_world)
        self.rank_couple = self.comm_couple.Get_rank()
        self.size_couple = self.comm_couple.Get_size()
        self.PE['filter'] = self.rank_couple == 0 and color == 0
        self.rank_world_filterpe = 0
